(*
  PWPW  Ver. 1.00
  
  Copyright (C) 2003 lethevert
  All rights reserved.
  
  web : http://www.geocities.jp/lethevert/index.html
  mail: lethevert@egroups.co.jp
  
  
  This file is part of PWPW.
  
  PWPW is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  PWPW is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public
  License along with PWPW; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)

unit CLCLPlugin;

{$X+}{$Z2}{$A8}

interface

uses
   Windows, Messages;

const
   BUF_SIZE                     = 256;

   // general
   WM_GET_VERSION               =  ( WM_APP + 100 );
   WM_GET_WORKPATH              =  ( WM_APP + 101 );
   WM_GET_CLIPBOARD_WATCH       =  ( WM_APP + 102 );
   WM_SET_CLIPBOARD_WATCH       =  ( WM_APP + 103 );
   WM_GET_FORMAT_ICON           =  ( WM_APP + 104 );
   WM_ENABLE_ACCELERATOR        =  ( WM_APP + 105 );
   WM_REGIST_HOTKEY             =  ( WM_APP + 106 );
   WM_UNREGIST_HOTKEY           =  ( WM_APP + 107 );
   // option
   WM_OPTION_SHOW               =  ( WM_APP + 200 );
   WM_OPTION_GET                =  ( WM_APP + 201 );
   WM_OPTION_LOAD               =  ( WM_APP + 202 );
   WM_OPTION_SAVE               =  ( WM_APP + 203 );
   // history & regist
   WM_HISTORY_CHANGED           =  ( WM_APP + 300 );
   WM_HISTORY_GET_ROOT          =  ( WM_APP + 301 );
   WM_HISTORY_LOAD              =  ( WM_APP + 302 );
   WM_HISTORY_SAVE              =  ( WM_APP + 303 );
   WM_REGIST_CHANGED            =  ( WM_APP + 350 );
   WM_REGIST_GET_ROOT           =  ( WM_APP + 351 );
   WM_REGIST_LOAD               =  ( WM_APP + 352 );
   WM_REGIST_SAVE               =  ( WM_APP + 353 );
   // item
   WM_ITEM_TO_CLIPBOARD         =  ( WM_APP + 400 );
   WM_ITEM_CREATE               =  ( WM_APP + 401 );
   { data_create_data, data_create_item, data_create_folder@Data.c
     VKf[^̍쐬
     Result : DATA_INFO VKf[^
     lparam : TYPE_DATÂƂAPAnsiChar format_name 'TEXT' 'BITMAP' Ȃ
              TYPE_ITEM, TYPE_FOLDER̂ƂAPAnsiChar title
     wparam : TYPE_DATA, TYPE_ITEM, TYPE_FOLDER
     
     ȂÅ֐͕KNilԂĂāAۂɂ͎gȂB
    }
   WM_ITEM_COPY                 =  ( WM_APP + 402 );
   { data_item_copy@Data.c
     qACe܂߂ĂɃRs[쐬B
     Result : DATA_INFO Rs[
     lparam : DATA_INFO Rs[
     wparam : BOOL nextȍ~̃ACeRs[邩ǂ }
   WM_ITEM_FREE                 =  ( WM_APP + 403 );
   WM_ITEM_FREE_DATA            =  ( WM_APP + 404 );
   WM_ITEM_CHECK                =  ( WM_APP + 405 );
   WM_ITEM_TO_BYTES             =  ( WM_APP + 406 );
   WM_ITEM_FROM_BYTES           =  ( WM_APP + 407 );
   WM_ITEM_TO_FILE              =  ( WM_APP + 408 );
   WM_ITEM_FROM_FILE            =  ( WM_APP + 409 );
   WM_ITEM_GET_PARENT           =  ( WM_APP + 410 );
   WM_ITEM_GET_FORMAT_TO_ITEM   =  ( WM_APP + 411 );
   WM_ITEM_GET_PRIORITY_HIGHEST =  ( WM_APP + 412 );
   WM_ITEM_GET_TITLE            =  ( WM_APP + 413 );
   WM_ITEM_GET_OPEN_INFO        =  ( WM_APP + 414 );
   WM_ITEM_GET_SAVE_INFO        =  ( WM_APP + 415 );
   // viewer
   WM_VIEWER_SHOW               =  ( WM_APP + 500 );
   WM_VIEWER_GET_HWND           =  ( WM_APP + 501 );
   WM_VIEWER_GET_MAIN_HWND      =  ( WM_APP + 504 );
   WM_VIEWER_GET_SELECTION      =  ( WM_APP + 502 );
   WM_VIEWER_SELECT_ITEM        =  ( WM_APP + 503 );

   // data type
   TYPE_DATA                    = 0;
   TYPE_ITEM                    = 1;
   TYPE_FOLDER                  = 2;
   TYPE_ROOT                    = 3;

   // c[s^C~O
   CALLTYPE_MENU                = 1;	// 상j[
   CALLTYPE_VIEWER              = 2;	// r[Ãj[
   CALLTYPE_VIEWER_OPEN         = 4;	// r[AJ
   CALLTYPE_VIEWER_CLOSE        = 8;	// r[A鎞
   CALLTYPE_ADD_HISTORY         = 16;	// f[^ɒǉ鎞
   CALLTYPE_ITEM_TO_CLIPBOARD   = 32;	// f[^Nbv{[hɑ鎞
   CALLTYPE_START               = 64;	// N
   CALLTYPE_END                 = 128;	// I
                                        // option only
   CALLTYPE_MENU_COPY_PASTE     = 256;	// Rs[Ɠ\t𑗂
                                        // execute only
   CALLTYPE_HISTORY             = 512;	// ̌Ăяo
   CALLTYPE_REGIST              = 1024;	// o^ACěĂяo

   // c[߂l
   TOOL_ERROR                   = 0;	// c[̃G[
   TOOL_SUCCEED                 = 1;	// c[̐I
   TOOL_CANCEL                  = 2;	// ȍ~̏LZ
   TOOL_DATA_MODIFIED           = 4;	// f[^ύX

   (* Struct *)
   // `擾
type
   PFORMAT_GET_INFO = ^FORMAT_GET_INFO;
   FORMAT_GET_INFO = record
      struct_size       : DWORD;	// \̂̃TCY

      format_name       : array[0..BUF_SIZE-1] of AnsiChar;
      func_header       : array[0..BUF_SIZE-1] of AnsiChar;
      comment           : array[0..BUF_SIZE-1] of AnsiChar;
   end;

   // c[擾
   PTOOL_GET_INFO = ^TOOL_GET_INFO;
   TOOL_GET_INFO = record
      struct_size       : DWORD;	// \̂̃TCY
      
      title             : array[0..BUF_SIZE-1] of AnsiChar;
      func_name         : array[0..BUF_SIZE-1] of AnsiChar;
      cmd_line          : array[0..BUF_SIZE-1] of AnsiChar;
      call_type         : Integer;	// CALLTYPE_
   end;

   // c[s
   PTOOL_EXEC_INFO = ^TOOL_EXEC_INFO;
   TOOL_EXEC_INFO = record
      struct_size       : DWORD;	// \̂̃TCY

      call_type         : Integer;	// CALLTYPE_
      cmd_line          : PAnsiChar;	// c[ݒŎw肵R}hC
      lParam            : LPARAM;	// c[ɑΉlongl
   end;

   // ACe
   PDATA_INFO = ^DATA_INFO;
   DATA_INFO = record
      struct_size       : DWORD;	// \̂̃TCY

      _type             : Integer;	// TYPE_
      title             : PAnsiChar;	// ^Cg

      format_name       : PAnsiChar;	// `
      format_name_hash  : Integer;	// `̃nbV
      format            : UINT;		// `l

      data              : THandle;	// f[^
      size              : DWORD;	// TCY

      modified          : TFileTime;	// XV
      window_name       : PAnsiChar;	// Rs[EBhE^Cg

      plugin_string     : PAnsiChar;	// vOCpf[^
      plugin_param      : LPARAM;

      // ȉۑȂ
      menu_title        : PAnsiChar;	// j[ɕ\^Cg (ݒ̏ꍇ͌`\)
      free_title        : BOOL;		// ^Cg TRUE- FALSE-Ȃ
      menu_icon         : HICON;	// j[ɕ\ACRnh
      free_icon         : BOOL;		// ACRnh TRUE- FALSE-Ȃ
      menu_bitmap       : HBITMAP;	// j[ɕ\rbg}bv
      free_bitmap       : BOOL;		// rbg}bvnh TRUE- FALSE-Ȃ
      menu_bmp_width    : Integer;	// j[ɕ\rbg}bv̌ʃTCY
      menu_bmp_height   : Integer;
      param1            : LPARAM;	// vOCpf[^
      param2            : LPARAM;

      child             : PDATA_INFO;
      next              : PDATA_INFO;

      // Ver 1.0.5
      hkey_id           : Integer;	// zbgL[
      op_modifiers      : UINT;
      op_virtkey        : UINT;
      op_paste          : Integer;
   end;

   // c[pACe
   PTOOL_DATA_INFO = ^TOOL_DATA_INFO;
   TOOL_DATA_INFO = record
      struct_size       : DWORD;	// \̂̃TCY

      di                : PDATA_INFO;	// ACe

      child             : PTOOL_DATA_INFO;
      next              : PTOOL_DATA_INFO;
   end;

implementation

end.
