(*
  PWPW  Ver. 1.00
  
  Copyright (C) 2003 lethevert
  All rights reserved.
  
  web : http://www.geocities.jp/lethevert/index.html
  mail: lethevert@egroups.co.jp
  
  
  This file is part of PWPW.
  
  PWPW is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  PWPW is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public
  License along with PWPW; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
unit PWManModule;

interface

uses
   Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, CLCLPlugin, PasswordGeneratorModule;

type
   TFrmPWMan = class(TForm)
      PWList         : TListBox;
      FldTitle       : TEdit;
      FldID          : TEdit;
      FldPassword    : TEdit;
      FldPasswordRule: TEdit;
      FldURL         : TEdit;
      FldComment     : TEdit;
      FldDateOfChange: TEdit;
      LblTitle       : TLabel;
      LblID          : TLabel;
      LblPassword    : TLabel;
      LblPasswordRule: TLabel;
      LblURL         : TLabel;
      LbComment      : TLabel;
      LblDateOfChange: TLabel;
      BtnGenerate    : TButton;
      BtnSave        : TButton;
      BtnReset       : TButton;
      BtnNew         : TButton;
      BtnUp          : TButton;
      BtnDown        : TButton;
      BtnDelete      : TButton;
      ComboBox1      : TComboBox;
      procedure SaveItem(Sender: TObject);
      procedure ResetItem(Sender: TObject);
      procedure NewItem(Sender: TObject);
      procedure PasswordGenerate(Sender: TObject);
      procedure ClickList(Sender: TObject);
      procedure ListUp(Sender: TObject);
      procedure ListDown(Sender: TObject);
    procedure DeleteItem(Sender: TObject);
    procedure ChangeComboBox1(Sender: TObject);
   private
      { Private 錾 }
      RootFolder     : PDATA_INFO;
      TrashFolder    : PDATA_INFO;
      currData       : PDATA_INFO;
      hWnd           : HWND;
      function Swap1stAnd2nd(di: PDATA_INFO): PDATA_INFO;
      function CreateAndSortItemData(inum: Integer; di: PDATA_INFO): PDATA_INFO;
      function SetItemData(di: PDATA_INFO; str: PAnsiChar): Boolean;
      procedure ChangeCurrData(cdi: PDATA_INFO);
      procedure UpdatePWList(rdi: PDATA_INFO);
   public
      { Public 錾 }
      procedure MyInitialize(rdi: PDATA_INFO; tdi: PDATA_INFO; h: HWND);
      
   end;
   
const
   ItemSize = 7;
   ItemName : array[1..ItemSize] of PAnsiChar  = ('ID',  'Password', 'OldPassword', 'PasswordRule', 'URL', 'Comment', 'DateOfChange');
   ItemNoPassword = 2;
   ItemNoOldPassword = 3;
   ItemNoDateOfChange = 7;
   
var
   FrmPWMan: TFrmPWMan;
   FldItemData : array[1..ItemSize] of TEdit; // ItemNameƑΉBMyInitializeŒlZbgĂB
   
implementation

{$R *.dfm}

{ CreateAndSortItemData
  TFrmPWMan.SaveItemŎgĂ֐B
  diȍ~AItemName[inum]Ɠ̂TāA
  A΁AdȋOɈړāAԂB
  AȂ΁AVITEMDATA쐬āAdȋOɕtāAԂB
 }
function TFrmPWMan.CreateAndSortItemData(inum: Integer; di: PDATA_INFO): PDATA_INFO;
var
   item_di : PDATA_INFO;
   pre_item_di : PDATA_INFO;
begin
      item_di := di;
      pre_item_di := Nil;
      while item_di <> Nil do
      begin
         if StrComp(item_di^.title, ItemName[inum]) = 0 then
            Break;
         pre_item_di := item_di;
         item_di := item_di.next;
      end;
      
      { ItemName[inum]Ɠ̂Ƃ }
      if item_di <> Nil Then
      begin
         if pre_item_di = Nil then
            Result := di
         Else
         begin
            pre_item_di^.next := item_di^.next;
            item_di^.next := di;
            Result := item_di;
         end;
      end
      { ItemName[inum]Ɠ̂ȂƂ }
      Else
      begin
         { ITEM̍쐬 }
         item_di := PDATA_INFO(LocalAlloc(LPTR, SizeOf(DATA_INFO)));
         if item_di = Nil then // Error
         Begin
            Result := Nil;
            Exit;
         End;
         item_di^.struct_size := SizeOf(DATA_INFO);
         item_di^._type := TYPE_ITEM;
         item_di^.title := PAnsiChar(LocalAlloc(LPTR, SizeOf(AnsiChar)*(StrLen(ItemName[inum])+1)));
         if item_di^.title <> Nil then
            StrCopy(item_di^.title, ItemName[inum]);
         { DATA̍쐬 }
         item_di^.child := PDATA_INFO(LocalAlloc(LPTR, SizeOf(DATA_INFO)));
         if item_di^.child = Nil then // Error
         begin
            LocalFree(Cardinal(item_di));
            Result := Nil;
            Exit;
         end;
         item_di^.child^.struct_size := SizeOf(DATA_INFO);
         item_di^.child^._type := TYPE_DATA;
         item_di^.child^.format := CF_TEXT;
         item_di^.child^.format_name := PAnsiChar(LocalAlloc(LPTR, SizeOf(AnsiChar)*5));
         if item_di^.child^.format_name <> Nil then
            StrCopy(item_di^.child^.format_name, PAnsiChar('TEXT'));
         item_di^.child^.format_name_hash := 1688; // fobKœǂݎl߂I `
         item_di^.child^.data := 0;
         item_di^.child^.size := 0;
         // LAȂAL̃R[hł͏肭Ȃ̂ŁAڍ쐬ĂB
         // item_di := PDATA_INFO(SendMessage(hWnd, WM_ITEM_CREATE, LPARAM(ItemName[inum]), TYPE_ITEM));
         // item_di^.child := PDATA_INFO(SendMessage(hWnd, WM_ITEM_CREATE, LPARAM(PAnsiChar('TEXT')), TYPE_DATA));
         // łAꂾƁACLCL̃o[WƂɁAR[h`FbNȂ΂ȂB
         // ɁAAlloc̑삪̂ŁA\ȂoOo邩B
         // data_create_item, data_create_data@Data.c ̃R[hQlɂĂB
         item_di^.next := di;
         Result := item_di;
      end;
end;

function TFrmPWMan.SetItemData(di: PDATA_INFO; str: PAnsiChar): Boolean;
var
   strdata: PAnsiChar;
begin
   { text_copy_data@fmt_Text.c ȂǂƁA
     GlobalAlloc(GHND, *ret_size) -- L106
     ȂǂƂĂB
     }
   strdata := GlobalLock(di^.data);
   if strdata = Nil then
   begin
      GlobalUnlock(di^.data);
      
      if str = Nil then
         Result := false
      else
      begin
         di^.size := StrLen(str) + 1;
         di^.data := GlobalAlloc(GHND, di^.size);
         strdata := PAnsiChar(GlobalLock(di^.data));
         StrCopy(strdata, str);
         GlobalUnlock(di^.data);
         
         Result := true;         
      end;
   end
   else if StrComp(strdata, str) <> 0 then
   begin
      GlobalUnlock(di^.data);
      GlobalFree(di^.data);
      
      di^.size := StrLen(str) + 1;
      di^.data := GlobalAlloc(GHND, di^.size);
      strdata := PAnsiChar(GlobalLock(di^.data));
      StrCopy(strdata, str);
      GlobalUnlock(di^.data);
      
      Result := true;
   end
   else
   begin
      GlobalUnlock(di^.data);
      Result := false;
   end;
end;

{ ʏɕ\ITEMDATA̕\ύX֐͂ꂾ }
procedure TFrmPWMan.ChangeCurrData(cdi: PDATA_INFO);
var
   folder_di : PDATA_INFO;
   str       : PAnsiChar;
   I         : Integer;
begin
   currData := cdi;
   
   { ܂AׂẴtB[h𔒎ɂ }
   FldTitle.Text := '';
   for I := 1 To ItemSize do
   begin
      if FldItemData[I] <> Nil then
         FldItemData[I].Text := '';
   end;
   

   // ACeNilł邩AtH_łȂ΁A{^𖳌
   if (currData = Nil) or (currData^._type <> TYPE_FOLDER) then
   begin
     BtnDelete.Hide;
     BtnSave.Hide;
     BtnReset.Hide;
   end
   else
   // ACetH_ł΁A{^LAf[^currDataŏ
   begin
     BtnDelete.Show;
     BtnSave.Show;
     BtnReset.Show;

     FldTitle.Text := string(currData^.title);

     folder_di  := currData^.child;
     while folder_di <> nil do
     begin
        str := folder_di^.title;
        
        { ϐFldItemDataƒ萔ItemName, ItemSize𗘗p }
        for I := 1 To ItemSize do
        begin
           if StrComp(str, ItemName[I]) = 0 then
           begin
              if FldItemData[I] <> Nil then
              begin
                 FldItemData[I].Text := string(PAnsiChar(GlobalLock(folder_di^.child^.data)));
                 GlobalUnlock(folder_di^.child^.data);
              end;
           end;
        end;
        
        folder_di := folder_di^.next;
     end;
   
     { DateOfChangẽf[^Ȃꍇ́ANo Dataƕ\ }
     if StrComp(PAnsiChar(FldDateOfChange.Text), '') = 0 then
        FldDateOfChange.Text := 'No Data';
   end;
end;

{ ʏɕ\PWList̕\ύX֐͂ꂾ }
procedure TFrmPWMan.UpdatePWList(rdi: PDATA_INFO);
var
   folder_di: PDATA_INFO;
begin
   RootFolder := rdi;
   PWList.Clear;
   
   folder_di := RootFolder^.child;
   while folder_di <> nil do
   begin
      if folder_di^._type = TYPE_FOLDER then
      begin
        PWList.AddItem(folder_di^.title, Pointer(folder_di));
      end;
      folder_di := folder_di^.next;
   end;
end;

procedure TFrmPWMan.SaveItem(Sender: TObject);
var
   folder_di: PDATA_INFO;
   str      : PAnsiChar;
   oldpassword : string;
   changed  : Boolean;
   pwchanged: Boolean;
   itemExist: array[1..ItemSize] of Boolean;
   I        : Integer;
begin
   if Application.MessageBox('ύXۑ܂B', 'PWPW', MB_OKCANCEL) <> IDOK then
      Exit;
   
   { tȌ }
   changed := false;
   pwchanged := false;
   for I := 1 To 6 do
   begin
      itemExist[I] := false;
   end;
   
   { TitleύXĂ΁AXV }
   str := PAnsiChar(FldTitle.Text);
   if StrComp(currData^.title, str) <> 0 then
   begin
      { LocalAllocŗ̈mۂ
        Õ|C^LocalFreeŉ }
      { ƂƂtitlẽ́̕A
        mem_alloc@Memory.c  LocalAlloc(LMEM_FIXED)gĂB
        mem_calloc@Memory.c  LocalAlloc(LPTR)gĂB PTR = FIXED or ZEROINIT
        mem_free@Memory.c  ŉ悤ɂȂĂB
        mem_debug@Memory.c DEBUG[hŁAall_alloc_size𐔂āA[NoĂ邪A
        DEBUGłȂ΋CɂKv͂ȂB }
      LocalFree(Cardinal(currData^.title));
      currData^.title := PAnsiChar(LocalAlloc(LMEM_FIXED, SizeOf(AnsiChar)*(StrLen(str)+1)));
      StrCopy(currData^.title, str);
      
      changed := true;
   end;
   
   { ȂITEMDATAǉāA𐮗񂳂ĂB
     gbL[ȋLqB }
   { ŏItemDataAʂ }
   currData^.child := CreateAndSortItemData(1, currData^.child);
   
   folder_di := currData^.child;
   for I := 2 To ItemSize do
   begin
      folder_di^.next := CreateAndSortItemData(I, folder_di^.next);
      folder_di := folder_di^.next;
      if folder_di = Nil then // Error
         Break;
   end;
   
   { ύXꂽITEMDATAXV }
   folder_di := currData^.child;
   while folder_di <> nil do
   begin
      str := folder_di^.title;
      
      { ϐFldItemDataƒ萔ItemName, ItemSize𗘗p }
      for I := 1 To ItemSize do
         if (I <> ItemNoDateOfChange) And (I <> ItemNoOldPassword) then
            { DateOfChangéApX[hɁAύXƂɌݓɍXVBƂŋLqB }
            if StrComp(str, ItemName[I]) = 0 then
            begin
               { ݂̃pX[hobNAbvB }
               if I = ItemNoPassword then
               begin
                  oldpassword := string(PAnsiChar(GlobalLock(folder_di^.child^.data)));
                  GlobalUnlock(folder_di^.child^.data);
               end;
               if SetItemData(folder_di^.child, PAnsiChar(FldItemData[I].Text)) then
               begin
                  changed := true;
                  { pX[h̕ύXƂ`FbNĂ }
                  if I = ItemNoPassword then
                     pwchanged := true;
               end;
            end;
      
      folder_di := folder_di^.next;
   end;
   
   { DateOfChangeXV }
   if pwchanged then
   begin
      folder_di := currData^.child;
      for I := 1 To ItemSize do
      begin
         str := folder_di^.title;
         if StrComp(str, ItemName[ItemNoDateOfChange]) = 0 then
            SetItemData(folder_di^.child, PAnsiChar(DateToStr(Date)))
         else if StrComp(str, Itemname[ItemNoOldPassword]) = 0 then
            SetItemData(folder_di^.child, PAnsiChar(oldpassword));
         folder_di := folder_di^.next;
      end;
   end;
   
   { ύXʒm }
   if changed then
   begin
      SendMessage(hWnd, WM_REGIST_CHANGED, 0, 0);
      UpdatePWList(RootFolder);
      ChangeCurrData(currData);
      if pwchanged then
         Application.MessageBox('ÂpX[h́AOldPasswordƂĕۑ܂B', 'PWPW', MB_OK)
   end
   Else
   begin
      Application.MessageBox('ύX͂܂łB', 'PWPW', MB_OK)
   end;
   
   { CLCL̃f[^Z[u }
   SendMessage(hWnd, WM_REGIST_SAVE, 0, 0);
end;

procedure TFrmPWMan.ResetItem(Sender: TObject);
begin
   ChangeCurrData(currData);
end;

procedure TFrmPWMan.NewItem(Sender: TObject);
var
   folder_di: PDATA_INFO;
begin
   { Folder̍쐬 }
   folder_di := PDATA_INFO(LocalAlloc(LPTR, SizeOf(DATA_INFO)));
   if folder_di = Nil then // Error
   Begin
      Exit;
   End;
   folder_di^.struct_size := SizeOf(DATA_INFO);
   folder_di^._type := TYPE_FOLDER;
   folder_di^.title := PAnsiChar(LocalAlloc(LPTR, SizeOf(AnsiChar)*(13)));
   if folder_di^.title <> Nil then
      StrCopy(folder_di^.title, 'New Password');
   //CreateAndSortItemData()ƓlɁAȉ̕͏肭ȂB
   //folder_di := PDATA_INFO(SendMessage(hWnd, WM_ITEM_CREATE, LPARAM(PAnsiChar('New Password')), TYPE_FOLDER));
   
   { VKtH_Xgɒǉ }
   if PWList.Count = 0 then
      RootFolder^.child := folder_di
   else
      PDATA_INFO(PWList.Items.Objects[PWList.Count-1])^.next := folder_di;
   
   { \XV }
   UpdatePWList(RootFolder);
   PWList.ItemIndex := PWList.Count-1;
   ChangeCurrData(PDATA_INFO(PWList.Items.Objects[PWList.ItemIndex]));
   
   { CLCL̃f[^Z[u }
   SendMessage(hWnd, WM_REGIST_SAVE, 0, 0);
end;

procedure TFrmPWMan.DeleteItem(Sender: TObject);
var
   idx: Integer;
   preData: PDATA_INFO;
begin
   if PWList.Count = 1 then
   begin
      Application.MessageBox('Ō̃ACe͍폜ł܂B', 'PWPW', MB_OK);
      Exit;
   end;
   
   idx := PWList.ItemIndex;
   
   { ݂̃ACePasswordFolder폜B}
   preData := PDATA_INFO(PWList.Items.Objects[idx-1]);
   preData^.next := currData^.next;
   currData^.next := Nil;
   
   { ݂̃ACeTrashFolderɒǉB }
   currData^.next := TrashFolder^.child;
   TrashFolder^.child := currData;
   
   { \XV }
   UpdatePWList(RootFolder);
   PWList.ItemIndex := idx-1;
   ChangeCurrData(PDATA_INFO(PWList.Items.Objects[PWList.ItemIndex]));
   
   { CLCL̃f[^Z[u }
   SendMessage(hWnd, WM_REGIST_SAVE, 0, 0);
end;

procedure TFrmPWMan.PasswordGenerate(Sender: TObject);
begin
   { PWGeneratorModuleĂяoāApX[hB
     pX[h́AFldPasswordɃZbgB }
   try
      FldPassword.Text := PWGenerate(PChar(FldPasswordRule.Text));
   except
      on err: EPWLexError do
      begin
         { G[ƃwv\ err.Message }
         Application.MessageBox('Password Generator Error', 'PWPW', MB_OK);
         FldPassword.Text := err.Message;
      end
   end;
end;

procedure TFrmPWMan.ClickList(Sender: TObject);
begin
   ChangeCurrData(PDATA_INFO(PWList.Items.Objects[PWList.ItemIndex]));
end;

function TFrmPWMan.Swap1stAnd2nd(di: PDATA_INFO): PDATA_INFO;
var
   next_di: PDATA_INFO;
begin
   if di = Nil then
   begin
      Result := Nil;
      Exit;
   end;
   
   next_di := di^.next;
   if next_di = Nil then
   begin
      Result := di;
      Exit;
   end;
   
   di^.next := next_di^.next;
   next_di^.next := di;
   Result := next_di;
end;

procedure TFrmPWMan.ListUp(Sender: TObject);
var
   idx: Integer;
begin
   { ListUp }
   idx := PWList.ItemIndex;
   if PWList.ItemIndex <= 0 then
      Exit
   Else
   begin
      if PWList.ItemIndex = 1 then
      begin
         RootFolder^.child := Swap1stAnd2nd(PDATA_INFO(PWList.Items.Objects[PWList.ItemIndex-1]));
      end
      Else
      begin
         PDATA_INFO(PWList.Items.Objects[PWList.ItemIndex-2])^.next :=
            Swap1stAnd2nd(PDATA_INFO(PWList.Items.Objects[PWList.ItemIndex-1]));
      end;
   end;
   UpdatePWList(RootFolder);
   PWList.ItemIndex := idx-1;
end;

procedure TFrmPWMan.ListDown(Sender: TObject);
var
   idx: Integer;
begin
   { ListDown }
   idx := PWList.ItemIndex;
   if (PWList.ItemIndex < 0) Or (PWList.ItemIndex >= PWList.Count-1) then
      Exit
   Else
   begin
      if PWList.ItemIndex = 0 then
      begin
         RootFolder^.child := Swap1stAnd2nd(PDATA_INFO(PWList.Items.Objects[PWList.ItemIndex]));
      end
      Else
      begin
         PDATA_INFO(PWList.Items.Objects[PWList.ItemIndex-1])^.next :=
            Swap1stAnd2nd(PDATA_INFO(PWList.Items.Objects[PWList.ItemIndex]));
      end;
   end;
   UpdatePWList(RootFolder);
   PWList.ItemIndex := idx+1;
end;

procedure TFrmPWMan.MyInitialize(rdi: PDATA_INFO; tdi: PDATA_INFO; h: HWND);
begin
   { A萔Ő錾łȂȁ` }
   hWnd := h;
   FldItemData[1] := FrmPWMan.FldID;
   FldItemData[2] := FrmPWMan.FldPassword;
   FldItemData[3] := Nil; // OldPassword
   FldItemData[4] := FrmPWMan.FldPasswordRule;
   FldItemData[5] := FrmPWMan.FldURL;
   FldItemData[6] := FrmPWMan.FldComment;
   FldItemData[7] := FrmPWMan.FldDateOfChange;
   
   { ݒ }
   TrashFolder := tdi;
   
   // rdinil̏ꍇ́AACeЂƂVK쐬B
   //if rdi^.child = nil then
   //begin
   //   RootFolder := rdi;
   //   PWList.Clear;
   //   NewItem(Nil);
   //end
   //else
   
   UpdatePWList(rdi);
   
   ComboBox1.Text := rdi^.title;

   If PWList.Count = 0 then
     ChangeCurrData(Nil)
   Else
   begin
     ChangeCurrData(PDATA_INFO(PWList.Items.Objects[0]));
   end;
end;


procedure TFrmPWMan.ChangeComboBox1(Sender: TObject);
begin
   RootFolder := PDATA_INFO(ComboBox1.Items.Objects[ComboBox1.ItemIndex]);
   UpdatePWList(RootFolder);

   If PWList.Count = 0 then
     ChangeCurrData(Nil)
   Else
   begin
     ChangeCurrData(PDATA_INFO(PWList.Items.Objects[0]));
   end;
end;

end.
