(*
  PWPW  Ver. 1.00
  
  Copyright (C) 2003 lethevert
  All rights reserved.
  
  web : http://www.geocities.jp/lethevert/index.html
  mail: lethevert@egroups.co.jp
  
  
  This file is part of PWPW.
  
  PWPW is free software; you can redistribute it and/or
  modify it under the terms of the GNU Lesser General Public
  License as published by the Free Software Foundation; either
  version 2.1 of the License, or (at your option) any later version.
  
  PWPW is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Lesser General Public License for more details.
  
  You should have received a copy of the GNU Lesser General Public
  License along with PWPW; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*)
unit PasswordGeneratorModule;

interface

uses
   SysUtils, Math;

function PWGenerate(rule: PAnsiChar): string; // throw EPWLexError

{ Password̍쐬 }
function SubPWGenerate(CSet: string; CSetLength: Integer): string;

type
   PWLexMode = (pwNumber, pwAddChars);
   EPWLexError = class(Exception);

const
   PWCSetDigits     : string = '0123456789';
   PWCSetLowerCases : string = 'abcdefghijklmnopqrstuvwxyz';
   PWCSetUpperCases : string = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ';
   (* CSymbols
      WindowsŃpX[hɗpłL
      ` ~ ! @ # $ % ^ & * ( ) _ + - = { } | [ ] \ : " ; ' < > ? , . /
   *)
   PWCSetSymbols    : string = '`~!@#$%^&*()_+-={}|[]\:";''<>?,./';
   
implementation

function PWGenerate(rule: PAnsiChar): string;
var
   Mode: PWLexMode;
   Password: string;
   CSet: string;
   CSetLength: Integer;
   idx: Integer;
begin
   Mode := pwNumber;
   Password := '';
   CSet := PWCSetDigits + PWCSetLowerCases + PWCSetUpperCases;
   CSetLength := 0;
   idx := 0;
   
   { ̏ }
   Randomize();
   
   while rule[idx] <> #0 do
   begin
      { []̊O : pX[h̒ }
      if Mode = pwNumber then
      begin
         {  }
         if rule[idx] in ['0'..'9'] then
         begin
            CSetLength := CSetLength * 10 + Ord(rule[idx]) - Ord('0');
         end
         { []̎n܂ }
         else if rule[idx] = '[' then
         begin
            Mode := pwAddChars;
            // Password̐
            if idx <> 0 then
               Password := Password + SubPWGenerate(CSet, CSetLength);
            CSet := '';
            CSetLength := 0;
         end
         { ̑̕ : G[ }
         else
         begin
            raise EPWLexError.Create('܂[ł͂܂B');
         end;
      end
         
      { []̓̏ : Zbg̍쐬 }
      else if Mode = pwAddChars then
      begin
         { ꕶ \a \A \d \c \C \! \\ \] }
         if rule[idx] = '\' then
         begin
            Inc(idx);
            Case rule[idx] of
               'a':
                  begin
                     CSet := CSet + PWCSetDigits + PWCSetLowerCases + PWCSetUpperCases;
                  end;
               'A':
                  begin
                     CSet := CSet + PWCSetDigits + PWCSetLowerCases + PWCSetUpperCases + PWCSetSymbols;
                  end;
               'd':
                  begin
                     CSet := CSet + PWCSetDigits;
                  end;
               'c':
                  begin
                     CSet := CSet + PWCSetLowerCases;
                  end;
               'C':
                  begin
                     CSet := CSet + PWCSetUpperCases;
                  end;
               '!':
                  begin
                     CSet := CSet + PWCSetSymbols;
                  end;
               '\':
                  begin
                     CSet := CSet + '\';
                  end;
               ']':
                  begin
                     CSet := CSet + ']';
                  end;
            else
               raise EPWLexError.Create('sȓꕶłB \' + rule[idx]);
            end;
         end
         { []̏I }
         else if rule[idx] = ']' then
         begin
            Mode := pwNumber;
         end
         { ʏ̕ }
         else
         begin
            CSet := CSet + rule[idx];
         end;
      end
      else
      begin
         raise EPWLexError.Create('vÖُłB');
      end;
      
      Inc(idx);
   end;
   
   if Mode = pwNumber then
   begin
      // Password̐
      Password := Password + SubPWGenerate(CSet, CSetLength);
   end
   else
   begin
      raise EPWLexError.Create(']Ă܂B');
   end;
   
   Result := Password;
end;

function SubPWGenerate(CSet: string; CSetLength: Integer): string;
var
   I: Integer;
   N: Integer;
begin
   Result := '';
   for I := 0 to CSetLength-1 do
   begin
      N := Length(CSet);
      N := Floor(Random(N)) + 1;
//      N := Floor(Random(Length(CSet)));
      Result := Result + CSet[N];
   end
end;

end.
